"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.sst = exports.s = exports.orSlashesB = exports.orSlashes = exports.ss = exports.TableV2 = exports.Table = exports.ParagraphAr = exports.Paragraph = exports.Row = exports.Column = exports.RText = exports.PageBreak = exports.Gap = exports.Pdf417 = exports.Spacer = exports.Qr = exports.Block = exports.PdfReport = exports.Report = void 0;
//
var Report = /** @class */ (function () {
    function Report(blocks, options) {
        this.blocks = blocks;
        this.margin = options === null || options === void 0 ? void 0 : options.margin;
        this.fontSize = options === null || options === void 0 ? void 0 : options.fontSize;
        this.dir = options === null || options === void 0 ? void 0 : options.dir;
    }
    return Report;
}());
exports.Report = Report;
var PdfReport = /** @class */ (function () {
    function PdfReport(detail, options) {
        this.detail = detail;
        if (options) {
            this.setOptions(options);
        }
    }
    PdfReport.prototype.setHeader = function (header) {
        this.header = header;
        return this;
    };
    PdfReport.prototype.setFooter = function (footer) {
        this.footer = footer;
        return this;
    };
    PdfReport.prototype.setOptions = function (options) {
        this.margin = options === null || options === void 0 ? void 0 : options.margin;
        this.fontSize = options === null || options === void 0 ? void 0 : options.fontSize;
        this.dir = options === null || options === void 0 ? void 0 : options.dir;
    };
    return PdfReport;
}());
exports.PdfReport = PdfReport;
var Block = /** @class */ (function () {
    function Block(type) {
        this.type = type;
    }
    Block.prototype.setBold = function () {
        this.bold = true;
        return this;
    };
    Block.prototype.setLineSpacing = function (value) {
        this.lineSpacing = value;
        return this;
    };
    Block.prototype.setNoBorder = function () {
        this.noBorder = true;
        return this;
    };
    Block.prototype.setNoOuterBorders = function () {
        this.noBottomBorder = true;
        this.noLeftBorder = true;
        this.noRightBorder = true;
        this.noTopBorder = true;
        return this;
    };
    Block.prototype.setNoInnerBorders = function () {
        this.noHorizontalInsideBorder = true;
        this.noVerticalInsideBorder = true;
        return this;
    };
    Block.prototype.setBorder = function (value) {
        this.border = value;
        return this;
    };
    Block.prototype.setTextAlign = function (value) {
        this.textAlign = value;
        return this;
    };
    Block.prototype.justify = function () {
        this.textAlign = "justify";
        return this;
    };
    Block.prototype.textLeft = function () {
        this.textAlign = "left";
        return this;
    };
    Block.prototype.textRight = function () {
        this.textAlign = "right";
        return this;
    };
    Block.prototype.textCenter = function () {
        this.textAlign = "center";
        return this;
    };
    Block.prototype.center = function () {
        this.align = "center";
        return this;
    };
    Block.prototype.left = function () {
        this.align = "left";
        return this;
    };
    Block.prototype.right = function () {
        this.align = "right";
        return this;
    };
    Block.prototype.pb = function (value) {
        this.paddingBottom = value;
        return this;
    };
    Block.prototype.pl = function (value) {
        this.paddingLeft = value;
        return this;
    };
    Block.prototype.pr = function (value) {
        this.paddingRight = value;
        return this;
    };
    Block.prototype.pt = function (value) {
        this.paddingTop = value;
        return this;
    };
    /**@deprecated use .p instead */
    Block.prototype.paddingAll = function (value) {
        return this.p(value);
    };
    Block.prototype.p = function (value) {
        this.paddingBottom = value;
        this.paddingLeft = value;
        this.paddingRight = value;
        this.paddingTop = value;
        return this;
    };
    /**@deprecated use .ph instead */
    Block.prototype.paddingRightLeft = function (value) {
        return this.ph(value);
    };
    Block.prototype.ph = function (value) {
        this.paddingLeft = value;
        this.paddingRight = value;
        return this;
    };
    Block.prototype.pv = function (value) {
        this.paddingBottom = value;
        this.paddingTop = value;
        return this;
    };
    Block.prototype.setSize = function (value) {
        this.size = value;
        return this;
    };
    Block.prototype.setTextDir = function (value) {
        this.textDir = value;
        return this;
    };
    Block.prototype.setAlign = function (value) {
        this.align = value;
        return this;
    };
    Block.prototype.ltr = function () {
        return this.setTextDir("ltr");
    };
    Block.prototype.rtl = function () {
        return this.setTextDir("rtl");
    };
    return Block;
}());
exports.Block = Block;
var Qr = /** @class */ (function (_super) {
    __extends(Qr, _super);
    function Qr(value) {
        var _this = _super.call(this, "qr") || this;
        _this.value = value;
        return _this;
    }
    return Qr;
}(Block));
exports.Qr = Qr;
var Spacer = /** @class */ (function (_super) {
    __extends(Spacer, _super);
    function Spacer(value) {
        var _this = _super.call(this, "spacer") || this;
        if (value) {
            _this.value = value.toString();
        }
        return _this;
    }
    return Spacer;
}(Block));
exports.Spacer = Spacer;
var Pdf417 = /** @class */ (function (_super) {
    __extends(Pdf417, _super);
    function Pdf417(value) {
        var _this = _super.call(this, "pdf417") || this;
        _this.value = value;
        return _this;
    }
    return Pdf417;
}(Block));
exports.Pdf417 = Pdf417;
var Gap = /** @class */ (function (_super) {
    __extends(Gap, _super);
    function Gap(size) {
        var _this = _super.call(this, "gap") || this;
        _this.size = size;
        return _this;
    }
    return Gap;
}(Block));
exports.Gap = Gap;
var PageBreak = /** @class */ (function (_super) {
    __extends(PageBreak, _super);
    function PageBreak() {
        return _super.call(this, "pageBreak") || this;
    }
    return PageBreak;
}(Block));
exports.PageBreak = PageBreak;
var RText = /** @class */ (function (_super) {
    __extends(RText, _super);
    function RText(value, enumName) {
        var _this = _super.call(this, "text") || this;
        _this.value = value;
        if (enumName)
            _this.enumName = enumName;
        return _this;
    }
    return RText;
}(Block));
exports.RText = RText;
var Column = /** @class */ (function (_super) {
    __extends(Column, _super);
    function Column(column) {
        var _this = _super.call(this, "column") || this;
        _this.column = column !== null && column !== void 0 ? column : [];
        return _this;
    }
    Column.prototype.add = function (block) {
        this.column.push(block);
        return this;
    };
    Column.prototype.setExpand = function () {
        this.expand = true;
        return this;
    };
    return Column;
}(Block));
exports.Column = Column;
var Row = /** @class */ (function (_super) {
    __extends(Row, _super);
    function Row(row) {
        var _this = _super.call(this, "row") || this;
        _this.row = row !== null && row !== void 0 ? row : [];
        return _this;
    }
    Row.prototype.add = function (child) {
        this.row.push(child);
        return this;
    };
    Row.prototype.setExpand = function () {
        this.expand = true;
        return this;
    };
    return Row;
}(Block));
exports.Row = Row;
var Paragraph = /** @class */ (function (_super) {
    __extends(Paragraph, _super);
    function Paragraph(value) {
        var _this = _super.call(this, value) || this;
        _this.justify();
        _this.setLineSpacing(0);
        _this.pb(8);
        return _this;
    }
    return Paragraph;
}(RText));
exports.Paragraph = Paragraph;
var ParagraphAr = /** @class */ (function (_super) {
    __extends(ParagraphAr, _super);
    function ParagraphAr(value) {
        var _this = _super.call(this, value) || this;
        _this.setLineSpacing(0);
        _this.pb(8);
        return _this;
    }
    return ParagraphAr;
}(RText));
exports.ParagraphAr = ParagraphAr;
/** @deprecated use TableV2 please */
var Table = /** @class */ (function (_super) {
    __extends(Table, _super);
    function Table(headers, tableOptions) {
        var _this = _super.call(this, "table") || this;
        _this.tableRows = [];
        if (headers) {
            _this.addRow().addColumn(headers.map(function (it) {
                var _a, _b, _c;
                var text = new RText(it)
                    .setSize(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.headerFontSize)
                    .setBold()
                    .center();
                if (tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingAll)
                    text.paddingAll(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingAll);
                if (tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingRightLeft)
                    text.paddingRightLeft(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingRightLeft);
                if ((_a = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _a === void 0 ? void 0 : _a.ph)
                    text.ph(tableOptions.header.ph);
                if ((_b = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _b === void 0 ? void 0 : _b.pv)
                    text.pv(tableOptions.header.pv);
                if ((_c = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _c === void 0 ? void 0 : _c.p)
                    text.p(tableOptions.header.p);
                return text;
            }));
        }
        return _this;
    }
    Table.prototype.addRow = function (blocks) {
        this.selectedRow = {
            tableColumns: blocks ? [{ reportBlocks: blocks }] : [],
        };
        this.tableRows.push(this.selectedRow);
        return this;
    };
    Table.prototype.addColumn = function (blocks) {
        if (!this.selectedRow)
            throw "Add Row first";
        this.selectedRow.tableColumns.push({ reportBlocks: blocks });
        return this;
    };
    Table.prototype.setFlexes = function (ints) {
        this.flexes = ints;
        return this;
    };
    Table.prototype.build = function () {
        delete this.selectedRow;
        return this;
    };
    return Table;
}(Block));
exports.Table = Table;
var TableV2 = /** @class */ (function (_super) {
    __extends(TableV2, _super);
    function TableV2(headers, tableOptions) {
        var _this = this;
        var _a;
        _this = _super.call(this, "table") || this;
        _this.tableOptions = tableOptions;
        _this.repeatFirstRow = (_a = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.repeatFirstRow) !== null && _a !== void 0 ? _a : false;
        _this.tableRowsV2 = [];
        if (headers && headers.length > 0) {
            _this.addRow(headers.map(function (it) {
                var _a, _b, _c;
                var text = new RText(it)
                    .setSize(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.headerFontSize)
                    .setBold()
                    .center();
                if (tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingAll)
                    text.paddingAll(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingAll);
                if (tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingRightLeft)
                    text.paddingRightLeft(tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.paddingRightLeft);
                if ((_a = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _a === void 0 ? void 0 : _a.ph)
                    text.ph(tableOptions.header.ph);
                if ((_b = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _b === void 0 ? void 0 : _b.pv)
                    text.pv(tableOptions.header.pv);
                if ((_c = tableOptions === null || tableOptions === void 0 ? void 0 : tableOptions.header) === null || _c === void 0 ? void 0 : _c.p)
                    text.p(tableOptions.header.p);
                return text;
            }));
        }
        return _this;
    }
    TableV2.prototype.addRow = function (blocks) {
        this.selectedRow = { cells: blocks !== null && blocks !== void 0 ? blocks : [] };
        this.tableRowsV2.push(this.selectedRow);
        return this;
    };
    TableV2.prototype.addCell = function (block) {
        var _a, _b, _c, _d;
        if (!this.selectedRow || !this.selectedRow.cells)
            throw "add row with cells first before adding cells";
        if (!block.paddingLeft &&
            !block.paddingRight &&
            ((_b = (_a = this.tableOptions) === null || _a === void 0 ? void 0 : _a.rows) === null || _b === void 0 ? void 0 : _b.ph)) {
            block.ph(this.tableOptions.rows.ph);
        }
        if (!block.paddingTop &&
            !block.paddingBottom &&
            ((_d = (_c = this.tableOptions) === null || _c === void 0 ? void 0 : _c.rows) === null || _d === void 0 ? void 0 : _d.pv)) {
            block.pv(this.tableOptions.rows.pv);
        }
        this.selectedRow.cells.push(block);
        return this;
    };
    TableV2.prototype.setFlexes = function (ints) {
        this.flexes = ints;
        return this;
    };
    TableV2.prototype.build = function () {
        delete this.selectedRow;
        return this;
    };
    return TableV2;
}(Block));
exports.TableV2 = TableV2;
/**
 * Wraps the given text in bold markdown syntax, or returns "**_UNDEFINED_**" if the text is null or undefined.
 * @param text - The text to be wrapped in bold markdown syntax.
 * @returns The input text wrapped in bold markdown syntax, or "**_UNDEFINED_**" if the input text is null or undefined.
 */
function ss(text) {
    return text ? "**".concat(text, "**") : "**_UNDEFINED_**";
}
exports.ss = ss;
/**
 * Returns the given text as a string, or a string of slashes if the text is falsy.
 * @param text - The text to return as a string, or a falsy value to return a string of slashes.
 * @returns The given text as a string, or a string of slashes if the text is falsy.
 */
function orSlashes(text) {
    return text ? "".concat(text) : "/////////";
}
exports.orSlashes = orSlashes;
function orSlashesB(text) {
    return text ? "**".concat(text, "**") : "/////////";
}
exports.orSlashesB = orSlashesB;
/**
 * Converts a value to a string, or returns "**_UNDEFINED_**" if the value is null or undefined.
 * @param text - The value to convert to a string.
 * @returns A string representation of the input value, or "**_UNDEFINED_**" if the input value is null or undefined.
 */
function s(text) {
    return text ? "".concat(text) : "**_UNDEFINED_**";
}
exports.s = s;
/**
 * Wraps the given text in bold markdown syntax and trim it, or returns "**_UNDEFINED_**" if the text is null or undefined.
 * If the text is undefined, null, or an empty string, returns "**_UNDEFINED_**".
 * @param text - The text to emphasize.
 * @returns The emphasized text, or "**_UNDEFINED_**" if the text is undefined, null, or an empty string.
 */
function sst(text) {
    return text ? "**".concat(text.toString().trim(), "**") : "**_UNDEFINED_**";
}
exports.sst = sst;
module.exports = {
    Report: Report,
    PdfReport: PdfReport,
    Block: Block,
    RText: RText,
    Table: Table,
    Gap: Gap,
    Pdf417: Pdf417,
    Qr: Qr,
    Paragraph: Paragraph,
    ParagraphAr: ParagraphAr,
    Column: Column,
    Row: Row,
    Spacer: Spacer,
    TableV2: TableV2,
    PageBreak: PageBreak,
    ss: ss,
    orSlashes: orSlashes,
    orSlashesB: orSlashesB,
    s: s,
};
