export interface IReport {
    dir?: string;
    fontSize?: number;
    margin?: IEdgeInsets;
    blocks: IReportBlock[];
}
export interface IEdgeInsets {
    right?: number;
    left?: number;
    top?: number;
    bottom?: number;
}
export interface IPdfReport {
    dir?: string;
    fontSize?: number;
    margin?: IEdgeInsets;
    header?: IReportBlock;
    detail: IReportBlock[];
    footer?: IReportBlock;
}
export interface IReportBlock {
    tableRows?: ITableRow[];
    tableRowsV2?: ITableRowV2[];
    repeatFirstRow?: boolean;
    type: string;
    value?: string;
    enumName?: string;
    bold?: boolean;
    flexes?: number[];
    colWidths?: ITableColWidth[];
    align?: string;
    textAlign?: string;
    textDir?: string;
    size?: number;
    paddingRight?: number;
    paddingLeft?: number;
    paddingTop?: number;
    paddingBottom?: number;
    lineSpacing?: number;
    border?: number;
    noBorder?: boolean;
    noHorizontalInsideBorder?: boolean;
    noVerticalInsideBorder?: boolean;
    noBottomBorder?: boolean;
    noLeftBorder?: boolean;
    noRightBorder?: boolean;
    noTopBorder?: boolean;
    expand?: boolean;
    column?: IReportBlock[];
    row?: IReportBlock[];
}
export interface ITableRow {
    tableColumns?: ITableColumn[];
}
export interface ITableRowV2 {
    cells?: IReportBlock[];
}
export interface ITableColWidth {
    index: number;
    type: string;
    value?: number;
}
export interface ITableColumn {
    reportBlocks?: IReportBlock[];
}
